diff --git a/Platforms/AMD/Styx/Binary/AmdModulePkg/Gionb/Gionb.efi b/Platforms/AMD/Styx/Binary/AmdModulePkg/Gionb/Gionb.efi
index bbd2e1c2ad9d42a3ce9a4442188807bdceba50b7..4cf762b8ad110ff2e27285ac2773b0e979792480 100644
GIT binary patch
diff --git a/Platforms/AMD/Styx/Binary/AmdModulePkg/Gionb/Gionb.inf b/Platforms/AMD/Styx/Binary/AmdModulePkg/Gionb/Gionb.inf
index 9b06cf6393c6..867fd513ff9b 100644
--- a/Platforms/AMD/Styx/Binary/AmdModulePkg/Gionb/Gionb.inf
+++ b/Platforms/AMD/Styx/Binary/AmdModulePkg/Gionb/Gionb.inf
@@ -41,11 +41,9 @@ ENTRY_POINT = PeiInitGionb
   AmdModulePkg/AmdModulePkg.dec
 
 [PatchPcd]
-  gAmdModulePkgTokenSpaceGuid.PcdPcieCoreConfiguration|2|0xa4d9
-  gAmdModulePkgTokenSpaceGuid.PcdPciePort0Present|1|0xa4c2
-  gAmdModulePkgTokenSpaceGuid.PcdPciePort1Present|1|0xa4ab
-  gAmdModulePkgTokenSpaceGuid.PcdPciePort2Present|1|0xa4d8
-  gAmdModulePkgTokenSpaceGuid.PcdPcieHardcodeEnumeration|TRUE|0xa4ac
-  gAmdModulePkgTokenSpaceGuid.PcdPcieGenMax|2|0xa4ad
-  gAmdModulePkgTokenSpaceGuid.PcdPcieGen3|0|0xa4c1
-  gAmdModulePkgTokenSpaceGuid.PcdPcieGen2|0|0xa4c0
+  gAmdModulePkgTokenSpaceGuid.PcdPcieCoreConfiguration|2|0x8B60
+  gAmdModulePkgTokenSpaceGuid.PcdPcieHardcodeEnumeration|TRUE|0x8C7C
+  gAmdModulePkgTokenSpaceGuid.PcdPcieGenMax|2|0x8ECC
+  gAmdModulePkgTokenSpaceGuid.PcdPciePort0Present|1|0x8ECD
+  gAmdModulePkgTokenSpaceGuid.PcdPciePort1Present|1|0x8ECE
+  gAmdModulePkgTokenSpaceGuid.PcdPciePort2Present|1|0x8ECF